

def sentry_extract(exp, username, password)
  exp.send username
  exp.expect /Password:/ do
    send password
  end
  exp.expect /Switched CDU:/ do
    send 'show system'
    sleep(5)
  end

  exp.expect /NIC S\/N:\s+(.*)$/ do
    puts "NIC Serial: #{exp.last_match.captures.first.strip}"
  end

  exp.expect /Switched CDU:/ do
    send 'show network'
    sleep(5)
  end

  exp.expect /IPv4 Address:\s+(.*)\s+Subnet Mask:.*$/ do
    puts "DHCP IP: #{exp.last_match.captures.first.strip}"
  end

  exp.expect /More \(Y\/es N\/o\):/ do
    send 'Y'
    sleep(5)
  end

  exp.expect /IPv4 Address:\s+(.*)\s+Subnet Mask:.*$/ do
    puts "Static IP: #{exp.last_match.captures.first.strip}"
  end

  exp.expect /More \(Y\/es N\/o\):/ do
    send 'Y'
  end

  exp.expect /Switched CDU:/ do
    send 'logout'
    sleep(5)
    exit
  end
end

def sentry_connect(host, port, username: 'admn', password: 'admn', **kwargs)
  connect_device(host, port, **kwargs) do |exp|
    exp.procedure.any do
      exp.expect /^\s+$/ do
        exp.send ''
      end

      exp.expect /Sentry Switched CDU/ do
        exp.send ''
      end

      exp.expect /Username:/ do
        sentry_extract(exp, username, password)
      end
    end
  end
end
